#include "../Framework3/OpenGL/OpenGLApp.h"

enum DrawMode {
	FrontToBack    = 0,
	BackToFront    = 1,
	RandomOrder    = 2,
	RandomWithPreZ = 3,
};

#define MAX_OVERDRAW 64

class App : public OpenGLApp {
public:
	char *getTitle() const { return "Benchmark"; }
	
	virtual void onButtonClicked(PushButton *button);

	bool init();
	bool load();
	void unload();

	void drawFrame();

private:
	void drawODQuad(const float z, const float t);
	float testOverDraw(const int overdrawFactor, const DrawMode mode, const bool complex);

	GLuint fp;

	TextureID wall;
	SamplerStateID trilinear;
	DepthStateID less;
	BlendStateID noColor;

	int nFrames, maxFrames;
	float startTime;
	bool isBenching;

	PushButton *bench;
	DropDownList *overDrawMode, *overDrawFactor;
	CheckBox *complex;
};
